var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
let ApiInitService = class ApiInitService {
    /*
    This loads Angular specific services/functions to the api that won't be downgraded
     */
    constructor(adminMetadataApiService, componentApiService, configApiService, configurationService, currentUserApiService, clientSearchApiService, eventApiService, fileApiService, httpApiService, localizationApiService, metadataApiService, objectApiService, pageAdminApiService, pageModelApiService, pageStateApiService, propertyApiService, refDataApiService, resourceApiService, searchApiService, sheetApiService, tabApiService, themeApiService, traversalApiService) {
        this.adminMetadataApiService = adminMetadataApiService;
        this.componentApiService = componentApiService;
        this.configApiService = configApiService;
        this.configurationService = configurationService;
        this.currentUserApiService = currentUserApiService;
        this.clientSearchApiService = clientSearchApiService;
        this.eventApiService = eventApiService;
        this.fileApiService = fileApiService;
        this.httpApiService = httpApiService;
        this.localizationApiService = localizationApiService;
        this.metadataApiService = metadataApiService;
        this.objectApiService = objectApiService;
        this.pageAdminApiService = pageAdminApiService;
        this.pageModelApiService = pageModelApiService;
        this.pageStateApiService = pageStateApiService;
        this.propertyApiService = propertyApiService;
        this.refDataApiService = refDataApiService;
        this.resourceApiService = resourceApiService;
        this.searchApiService = searchApiService;
        this.sheetApiService = sheetApiService;
        this.tabApiService = tabApiService;
        this.themeApiService = themeApiService;
        this.traversalApiService = traversalApiService;
    }
    createSviApi() {
        const api = {};
        window.sas = window.sas ?? {};
        window.sas.vi = api;
        this.addCommonApiModules(api);
        if (this.isClientApi(api)) {
            this.addClientApiModules(api);
        }
        else {
            this.addAdminApiModules(api);
        }
    }
    addCommonApiModules(api) {
        api.component = this.componentApiService.getApi();
        api.config = this.configApiService.getApi();
        api.currentUser = this.currentUserApiService.getApi();
        api.event = this.eventApiService.getApi();
        api.file = this.fileApiService.getApi();
        api.http = this.httpApiService.getApi();
        api.localization = this.localizationApiService.getApi();
        api.metadata = this.metadataApiService.getApi();
        api.pageAdmin = this.pageAdminApiService.getApi();
        api.pageModel = this.pageModelApiService.getApi();
        api.pageState = this.pageStateApiService.getApi();
        api.property = this.propertyApiService.getApi();
        api.refData = this.refDataApiService.getApi();
        api.resource = this.resourceApiService.getApi();
        api.search = this.searchApiService.getApi();
        api.theme = this.themeApiService.getApi();
        api.traversal = this.traversalApiService.getApi();
    }
    addClientApiModules(api) {
        api.object = this.objectApiService.getApi();
        api.search = this.clientSearchApiService.getApi();
        api.sheet = this.sheetApiService.getApi();
        api.tab = this.tabApiService.getApi();
    }
    addAdminApiModules(api) {
        api.metadata = this.adminMetadataApiService.getApi();
    }
    isClientApi(api) {
        return !this.configurationService.isAdmin() && !!api;
    }
};
ApiInitService = __decorate([
    Injectable({
        providedIn: "root"
    })
], ApiInitService);
export { ApiInitService };
