var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { map } from "rxjs/operators";
let ConfigApiService = class ConfigApiService {
    constructor(networkConfigService, controlService) {
        this.networkConfigService = networkConfigService;
        this.controlService = controlService;
        this.getSoftExpansionLimit = () => {
            return this.networkConfigService.getSoftExpansionLimit().toPromise();
        };
        this.getHardExpansionLimit = () => {
            return this.networkConfigService.getHardExpansionLimit().toPromise();
        };
        this.getSolutions = () => {
            return this.solutions;
        };
        this.registerSolution = (key, label, version) => {
            if (key && label && !this.solutions.has(key)) {
                this.solutions.set(key, { label, version });
            }
        };
        this.getSolutionExtension = (name) => {
            return this.controlService
                .whenInitialized()
                .pipe(map(() => this.controlService.getControlByName(name)))
                .toPromise();
        };
        this.registerSolutionExtension = (config) => {
            return this.controlService.registerControl(config).toPromise();
        };
        this.solutions = new Map();
    }
    getApi() {
        return {
            getSoftExpansionLimit: this.getSoftExpansionLimit,
            getHardExpansionLimit: this.getHardExpansionLimit,
            getSolutions: this.getSolutions,
            registerSolution: this.registerSolution,
            getSolutionExtension: this.getSolutionExtension,
            registerSolutionExtension: this.registerSolutionExtension
        };
    }
};
ConfigApiService = __decorate([
    Injectable({
        providedIn: "root"
    })
], ConfigApiService);
export { ConfigApiService };
