var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { pick } from "lodash-es";
let CurrentUserApiService = class CurrentUserApiService {
    constructor(configurationService, featureService, identitiesService) {
        this.configurationService = configurationService;
        this.featureService = featureService;
        this.identitiesService = identitiesService;
        this.getSessionDetails = () => {
            return pick(this.configurationService.getSessionDetails(), [
                "authorizedFeatures",
                "displayName",
                "id",
                "softwareVersionNumber"
            ]);
        };
        this.getUserDetails = () => {
            return this.identitiesService.getUserDetails(this.userId).toPromise();
        };
        this.getUserMemberships = () => {
            return this.identitiesService.getUserMemberships(this.userId).toPromise();
        };
        this.hasAdminFeatures = () => {
            return this.featureService.hasAdminFeatures();
        };
        this.hasFeatures = (features) => {
            return this.featureService.hasRequiredFeatures(features);
        };
        this.userId = configurationService.getSessionDetails().id;
    }
    getApi() {
        return {
            getSessionDetails: this.getSessionDetails,
            getUserDetails: this.getUserDetails,
            getUserMemberships: this.getUserMemberships,
            hasAdminFeatures: this.hasAdminFeatures,
            hasFeatures: this.hasFeatures
        };
    }
};
CurrentUserApiService = __decorate([
    Injectable()
], CurrentUserApiService);
export { CurrentUserApiService };
