var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
let HttpApiService = class HttpApiService {
    constructor(httpClient) {
        this.httpClient = httpClient;
        this.getApi = () => {
            return {
                get: this.get.bind(this),
                head: this.head.bind(this),
                post: this.post.bind(this),
                put: this.put.bind(this),
                patch: this.patch.bind(this),
                delete: this.delete.bind(this),
                options: this.options.bind(this),
                request: this.request.bind(this)
            };
        };
    }
    get(url, options) {
        return this.httpClient.get(url, options);
    }
    /**
     * @typedef {Object} HttpApiService~HeadOptions
     * @property [headers] {Record<string, string | string[]>}
     * @property [params] {Record<string, string | string[]>}
     */
    /**
     * Constructs a `HEAD` request that returns a null body and the full HttpResponse.
     *
     * @param url {string} Endpoint URL.
     * @param options {HttpApiService~HeadOptions} HTTP options to send with the request.
     * @return {Promise<HttpResponse<null>>} A Promise of the HttpResponse for the request with the response body of null.
     */
    head(url, options) {
        return this.httpClient.head(url, options);
    }
    post(url, body, options) {
        return this.httpClient.post(url, body, options);
    }
    put(url, body, options) {
        return this.httpClient.put(url, body, options);
    }
    patch(url, body, options) {
        return this.httpClient.patch(url, body, options);
    }
    delete(url, options) {
        return this.httpClient.delete(url, options);
    }
    options(url, options) {
        return this.httpClient.options(url, options);
    }
    request(method, url, options) {
        return this.httpClient.request(method, url, options);
    }
};
HttpApiService = __decorate([
    Injectable()
], HttpApiService);
export { HttpApiService };
