var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { getAngularJsInjectable, promiseWrap } from "../../commons/angular-angularjs-utils";
let MetadataApiService = class MetadataApiService {
    constructor(linksMetadataService, picklistService, sandMetadataService, spbEntityMetadataService) {
        this.linksMetadataService = linksMetadataService;
        this.picklistService = picklistService;
        this.sandMetadataService = sandMetadataService;
        this.spbEntityMetadataService = spbEntityMetadataService;
        this.dataDictionaryService = () => getAngularJsInjectable("dataDictionaryService");
        this.getEntityAccessRules = (objectType) => {
            return {
                create: this.dataDictionaryService().canCreateDataSourceType(objectType),
                read: this.dataDictionaryService().canReadDataSourceType(objectType),
                update: this.dataDictionaryService().canUpdateDataSourceType(objectType)
            };
        };
        this.getEntity = (objectType) => {
            return this.dataDictionaryService().getDataSource(objectType);
        };
        this.getField = (objectType, fieldName) => {
            return this.dataDictionaryService().getFieldMetadata(objectType, fieldName);
        };
        this.getManagedEntityTypes = () => {
            return this.dataDictionaryService().getManagedDocumentTypes();
        };
        this.getRootTypes = () => {
            return this.dataDictionaryService().getRootTypes();
        };
        this.getChildEntityTypes = (objectType) => {
            return this.dataDictionaryService().getSubDocumentTypes({ name: objectType });
        };
        this.getAllValidRelationshipTypes = (objectType, relationshipObjectType, relationshipName) => {
            const relateToMenuService = getAngularJsInjectable("relateToMenuService");
            return relateToMenuService.getAllValidLinkTypes(objectType, relationshipObjectType, relationshipName);
        };
        this.getResolvedEntities = () => {
            return this.dataDictionaryService().getEntities();
        };
        this.getResolvedEntityMetadata = (objectType) => {
            return this.dataDictionaryService().getEntityMetadata(objectType);
        };
        this.getIconForEntity = (objectType, iconType) => {
            return this.spbEntityMetadataService.getIconForEntity(objectType, iconType);
        };
        /**
         * @deprecated Use `getRootTypes()` and `getResolvedEntities()` instead.
         */
        this.getSearchMetadata = () => {
            return this.sandMetadataService.getMetadata().toPromise();
        };
        this.getReferenceData = (refDataName, options) => {
            return this.picklistService.getPicklist(refDataName, options).toPromise();
        };
        this.getRelationshipsFilteredByEndType = (endType, includeHeterogeneous = false) => {
            return this.linksMetadataService.getLinksFilteredByEndType(endType, includeHeterogeneous).toPromise();
        };
    }
    getApi() {
        return {
            getEntityAccessRules: this.getEntityAccessRules,
            getEntity: promiseWrap(this.getEntity),
            getField: promiseWrap(this.getField),
            getManagedEntityTypes: promiseWrap(this.getManagedEntityTypes),
            getRootTypes: promiseWrap(this.getRootTypes),
            getChildEntityTypes: promiseWrap(this.getChildEntityTypes),
            getAllValidRelationshipTypes: promiseWrap(this.getAllValidRelationshipTypes),
            getIconForEntity: this.getIconForEntity,
            getResolvedEntities: promiseWrap(this.getResolvedEntities),
            getResolvedEntityMetadata: promiseWrap(this.getResolvedEntityMetadata),
            getSearchMetadata: this.getSearchMetadata,
            getReferenceData: this.getReferenceData,
            getRelationshipsFilteredByEndType: this.getRelationshipsFilteredByEndType
        };
    }
};
MetadataApiService = __decorate([
    Injectable()
], MetadataApiService);
export { MetadataApiService };
