var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { getAngularJsInjectable } from "../../commons/angular-angularjs-utils";
let PageStateApiService = class PageStateApiService {
    constructor(spbPageStateService) {
        this.spbPageStateService = spbPageStateService;
        this.pageDesignerConfig = () => getAngularJsInjectable("spbPageDesignerConfigService");
        this.tabs = () => getAngularJsInjectable("TabService");
        this.getCurrentPageState = () => {
            return this.spbPageStateService.getCurrentState();
        };
        this.getPageState = (id) => {
            return this.spbPageStateService.get(id);
        };
        this.addPageState = (id, state) => {
            this.spbPageStateService.add(id, state);
        };
        this.removePageState = (id) => {
            this.spbPageStateService.remove(id);
        };
        this.getCurrentHomepageDesigner = () => {
            if (!this.isOnHomepageDesigner())
                return undefined;
            return this.spbPageStateService.getCurrentState();
        };
        this.getCurrentObjectPageDesigner = () => {
            if (!this.isOnObjectPageDesigner())
                return undefined;
            return this.spbPageStateService.getCurrentState();
        };
    }
    getApi() {
        return {
            getCurrent: this.getCurrentPageState,
            get: this.getPageState,
            add: this.addPageState,
            remove: this.removePageState,
            getCurrentHomepageDesigner: this.getCurrentHomepageDesigner,
            getCurrentObjectPageDesigner: this.getCurrentObjectPageDesigner
        };
    }
    isOnPageDesigner() {
        return this.tabs().getActiveTab().type === "pageTemplate";
    }
    isOnHomepageDesigner() {
        if (!this.isOnPageDesigner())
            return false;
        const state = this.spbPageStateService.getCurrentState();
        if (!state)
            return false;
        return this.pageDesignerConfig().getDesignerConfig(state.designerType).templateType === "homepage";
    }
    isOnObjectPageDesigner() {
        if (!this.isOnPageDesigner())
            return false;
        const state = this.spbPageStateService.getCurrentState();
        if (!state)
            return false;
        return this.pageDesignerConfig().getDesignerConfig(state.designerType).templateType === "page";
    }
};
PageStateApiService = __decorate([
    Injectable()
], PageStateApiService);
export { PageStateApiService };
