var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { getAngularJsInjectable, promiseWrap } from "../../commons/angular-angularjs-utils";
let RefDataApiService = class RefDataApiService {
    constructor() {
        this.referenceDataAdmin = () => getAngularJsInjectable("fdhReferenceDataAdmin");
        this.getReferenceLists = () => {
            return this.referenceDataAdmin().getReferenceLists();
        };
        this.getReferenceHierarchies = () => {
            return this.referenceDataAdmin().getReferenceHierarchies();
        };
        this.getReferenceListByName = (name, includeArchived) => {
            // Negating includeArchived as referenceDataAdmin.getListByName handles this opposite to getHierarchyByName.
            const promise = this.referenceDataAdmin().getListByName(name, !includeArchived);
            return promise.catch(error => Promise.reject(error?.data?.message));
        };
        this.getReferenceHierarchyByName = (name, includeArchived) => {
            const promise = this.referenceDataAdmin().getHierarchyByName(name, includeArchived);
            return promise.catch(error => Promise.reject(error?.data?.message));
        };
    }
    getApi() {
        return {
            getReferenceLists: promiseWrap(this.getReferenceLists),
            getReferenceHierarchies: promiseWrap(this.getReferenceHierarchies),
            getReferenceList: promiseWrap(this.getReferenceListByName),
            getReferenceHierarchy: promiseWrap(this.getReferenceHierarchyByName)
        };
    }
};
RefDataApiService = __decorate([
    Injectable()
], RefDataApiService);
export { RefDataApiService };
