var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
/**
 * This service is an intermediary between the client API and the Network.
 * It keeps a record of network menu handlers registered via the client API.
 */
let NetworkMenuHandlerService = class NetworkMenuHandlerService {
    constructor() {
        this.networkMenuHandlers = new Map();
    }
    /**
     * Call the registered callback function to modify/extend the context menu
     * @param menuType The type of menu
     * @param menu The menu object to be modified
     * @param workspaceClientId The Client ID of the current workspace
     */
    extendNetworkContextMenu(menuType, menu, workspaceClientId) {
        this.networkMenuHandlers.get(menuType)?.(menu, workspaceClientId);
    }
    /**
     * Register a callback function for the given menu type
     * @param menuType The type of menu: Node or Network
     * @param callback The callback function
     */
    registerNetworkMenuCallback(menuType, callback) {
        this.networkMenuHandlers.set(menuType, callback);
    }
};
NetworkMenuHandlerService = __decorate([
    Injectable({
        providedIn: "root"
    })
], NetworkMenuHandlerService);
export { NetworkMenuHandlerService };
