var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable } from "@angular/core";
import { getAngularJsInjectable } from "../../commons/angular-angularjs-utils";
import { zoneWrap } from "../../commons/api-utils";
let TabApiService = class TabApiService {
    constructor(ngZone) {
        this.ngZone = ngZone;
        this.tabService = () => getAngularJsInjectable("spbDocumentTabService");
        this.openTab = (objectType, objectId, suppressNavigation = false, mode = "open" /* OPEN */) => {
            return this.tabService().openDocumentTab(objectId, objectType, suppressNavigation, mode);
        };
        this.isOpenTabDirty = (objectType, objectId) => {
            return this.tabService().getDirty(objectType, objectId);
        };
        this.setOpenTabDirty = (objectType, objectId, dirtyState) => {
            return this.tabService().setTabDirtyState(objectType, objectId, dirtyState);
        };
    }
    getApi() {
        return {
            openTab: zoneWrap(this.openTab, this.ngZone),
            isOpenTabDirty: this.isOpenTabDirty,
            setOpenTabDirty: zoneWrap(this.setOpenTabDirty, this.ngZone)
        };
    }
};
TabApiService = __decorate([
    Injectable()
], TabApiService);
export { TabApiService };
